Loading...
Searching...
No Matches
BALL::VIEW::AddCartoonModel Class Reference
Visualisation » Model Processors

`#include <BALL/VIEW/MODELS/cartoonModel.h>`

Inheritance diagram for BALL::VIEW::AddCartoonModel:

## Public Types

enum | Types { STRAND = NUCLEIC_ACID + 1 , HELIX }
Public Types inherited from BALL::UnaryFunctor< ArgumentType, ResultType >
typedef ResultType | result_type
typedef ArgumentType | argument_type
typedef ArgumentType & | argument_reference
typedef const ArgumentType & | const_argument_reference
typedef ArgumentType * | argument_pointer
typedef const ArgumentType * | const_argument_pointer

## Public Member Functions

| AddCartoonModel ()
| Default Constructor.
| AddCartoonModel (const AddCartoonModel &cartoon_model)
| Copy constructor.
virtual | ~AddCartoonModel ()
| Destructor.
void | setHelixRadius (float radius)
float | getHelixRadius () const
void | setArrowWidth (float width)
float | getArrowWidth () const
void | setStrandHeight (float heigth)
float | getStrandHeight () const
void | setStrandWidth (float w)
float | getStrandWidth () const
void | setDNABaseRadius (float r)
float | getDNABaseRadius () const
void | setDNAHelixRadius (float r)
float | getDNAHelixRadius () const
void | setDNALadderRadius (float r)
float | getDNALadderRadius () const
void | setDrawDNAAsLadderModel (bool state)
bool | drawDNAAsLadderModel ()
void | enableRibbons (bool state)
bool | ribbonsEnabled () const
Public Member Functions inherited from BALL::VIEW::AddBackboneModel
| AddBackboneModel ()
| Default Constructor.
| AddBackboneModel (const AddBackboneModel &add_Backbone_model)
| Copy constructor.
virtual | ~AddBackboneModel ()
| Destructor.
virtual void | clear ()
virtual bool | start ()
virtual Processor::Result | operator() (Composite &composite)
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setTubeRadius (float radius)
float | getTubeRadius () const
virtual bool | createGeometricObjects ()
void | setRibbonMode (bool state)
bool | ribbonModeEnabled () const
Public Member Functions inherited from BALL::VIEW::ModelProcessor
| ModelProcessor ()
| ModelProcessor (const ModelProcessor &model_processor)
virtual | ~ModelProcessor ()
virtual bool | isValid () const
virtual void | clearComposites ()
GeometricObjectList & | getGeometricObjects ()
| Return the list with the created geometric objects.
const GeometricObjectList & | getGeometricObjects () const
| Return the list with the created geometric objects.
void | setDrawingPrecision (Index precision)
Index | getDrawingPrecision () const
void | setSurfaceDrawingPrecision (float precision)
float | getSurfaceDrawingPrecision () const
Public Member Functions inherited from BALL::UnaryProcessor< Composite >
| UnaryProcessor ()
| UnaryProcessor (const UnaryProcessor &)
virtual | ~UnaryProcessor ()
virtual bool | finish ()
Public Member Functions inherited from BALL::PropertyManager
BALL_INLINE | PropertyManager ()
| Default constructor.
BALL_INLINE | PropertyManager (const PropertyManager &property_manager)
| Copy constructor.
virtual | ~PropertyManager ()
| Destructor.
virtual void | destroy ()
| Clears all properties.
void | set (const PropertyManager &property_manager)
const PropertyManager & | operator= (const PropertyManager &property_manager)
void | get (PropertyManager &property_manager) const
void | swap (PropertyManager &property_manager)
BitVector & | getBitVector ()
const BitVector & | getBitVector () const
| operator BitVector & ()
void | setProperty (Property property)
void | clearProperty (Property property)
void | toggleProperty (Property property)
Size | countProperties () const
const NamedProperty & | getNamedProperty (Position index) const
NamedProperty & | getNamedProperty (Position index)
void | setProperty (const NamedProperty &property)
void | setProperty (const std::string &name)
void | setProperty (const std::string &name, bool value)
void | setProperty (const std::string &name, int value)
void | setProperty (const std::string &name, unsigned int value)
void | setProperty (const std::string &name, float value)
void | setProperty (const std::string &name, double value)
void | setProperty (const std::string &name, const std::string &value)
void | setProperty (const std::string &name, const PersistentObject &value)
const NamedProperty & | getProperty (const std::string &name) const
NamedPropertyIterator | beginNamedProperty ()
NamedPropertyIterator | endNamedProperty ()
void | clearProperty (const std::string &name)
Size | countNamedProperties () const
bool | hasProperty (Property property) const
| Query for an unnamed property.
bool | hasProperty (const std::string &name) const
| Query for a named property.
bool | operator== (const PropertyManager &pm) const
bool | operator!= (const PropertyManager &pm) const
| Inequality operator.
void | write (PersistenceManager &pm) const
| Persistent stream writing.
bool | read (PersistenceManager &pm)
| Persistent stream reading.
bool | isValid () const
void | dump (std::ostream &s=std::cout, Size depth=0) const

## Protected Member Functions

void | insertTriangle_ (Position v1, Position v2, Position v3, Mesh &mesh)
void | drawStrand_ (const Vector3 &start, Vector3 &right, Vector3 &hn, float arrow_width, Position &last_vertices, Mesh &mesh)
void | calculateComplementaryBases_ (const Composite &composite)
bool | assignNucleotideAtoms_ (Residue &r, Size nr_atoms, String atom_names[10], Atom *atoms[10])
void | drawRiboseAtoms_ (const Atom *atom1, const Atom *atom2, const Vector3 &v1, const Vector3 &v2)
void | calculateModelParts (Protein &protein)
void | assignModelType (ModelPart &part)
void | createModel_ (Position set_pos, Position part_pos)
void | createStrand_ (Position set_pos, Position part_pos)
void | createHelix_ (Position set_first, Position part_pos)
void | createTubeHelix_ (Position set_first, Position part_pos)
void | createWatsonCrickModel_ (Position set_pos, Position part_pos)
void | createSimpleNucleicAcid_ (Position set_pos, Position part_pos)
void | renderNucleotideOutline_ (const vector< Vector3 > &positions, Vector3 uv, Mesh &mesh)
Mesh * | createDoubleRing_ (const vector< Vector3 > &positions)
Mesh * | create6Ring_ (vector< Vector3 > positions)
virtual void | refineGuidePoints_ ()
Protected Member Functions inherited from BALL::VIEW::AddBackboneModel
virtual bool | collectPositions (vector< Residue * > residues)
virtual void | calculateGuidePoints_ ()
virtual void | createTube_ (Position set_pos, Position model_pos)
virtual void | createRibbon_ (Position set_pos, Position model_pos)
virtual void | interpolate_ ()
virtual void | refineModelParts_ ()
virtual void | clear_ ()
void | evaluateBSpline (const Vector3 &v1, const Vector3 &v2, const Vector3 &v3, float x, Vector3 &result)
bool | residuesAreConnected_ (Residue &residue1, Residue &residue2)
void | calculateTubePoints_ (Vector3 right, Vector3 dir, vector< Vector3 > &points)
void | calculateRibbonPoints_ (Vector3 xn, Vector3 dir, vector< Vector3 > &points)
void | calculateRibbonEllipse_ (float ribbon_width, float ribbon_height)

## Protected Attributes

float | helix_radius_
float | helix_height_
float | helix_width_
float | arrow_width_
float | strand_width_
float | strand_height_
float | DNA_helix_radius_
float | DNA_ladder_radius_
float | DNA_base_radius_
float | ribbon_width_
float | ribbon_radius_
bool | draw_DNA_as_ladder_
bool | draw_ribbon_
HashMap< const Residue *, const Residue * > | complementary_bases_
Protected Attributes inherited from BALL::VIEW::AddBackboneModel
float | tube_radius_
Size | interpolation_steps_
Size | number_of_ribbons_
float | ribbon_width_
float | ribbon_height_
bool | care_for_SS_
bool | ribbon_mode_
vector< vector< vector< Vector3 > > > | guide_points_
vector< vector< vector< Vector3 > > > | interpolated_points_
vector< vector< Vector3 > > | backbone_
vector< vector< Vector3 > > | offsets_
vector< vector< ModelPart > > | model_parts_
Protein | dummy_protein_
Chain | dummy_chain_
SecondaryStructure | dummy_ss_
HashSet< Residue * > | residues_to_be_rendered_
Protein * | last_protein_
vector< vector< Index > > | ss_
Size | slides_
Position | middle_slide_
Position | middle_ribbon_
Angle | slides_angle_
Matrix4x4 | temp_matrix_
vector< float > | xs_
vector< float > | ys_
Protected Attributes inherited from BALL::VIEW::ModelProcessor
GeometricObjectList | geometric_objects_
Index | drawing_precision_
float | surface_drawing_precision_

## Additional Inherited Members

Protected Types inherited from BALL::VIEW::AddBackboneModel
enum | ModelTypes { TUBE , RIBBON , NUCLEIC_ACID }

## Detailed Description

AddCartoonModel class. The class AddCartoonModel is a model processor that creates a Cartoon model through the CA-atoms of the processed Composite object. For information about the processor concept see Processor in the BALL documentation.

Definition at line 28 of file cartoonModel.h.

## Member Enumeration Documentation

## Types

enum BALL::VIEW::AddCartoonModel::Types

Enumerator
STRAND |
HELIX |

Definition at line 33 of file cartoonModel.h.

## Constructor & Destructor Documentation

## AddCartoonModel() [1/2]

BALL::VIEW::AddCartoonModel::AddCartoonModel | ( |  | ) |

Default Constructor.

## AddCartoonModel() [2/2]

BALL::VIEW::AddCartoonModel::AddCartoonModel | ( | const AddCartoonModel & | cartoon_model | ) |

Copy constructor.

## ~AddCartoonModel()

virtual BALL::VIEW::AddCartoonModel::~AddCartoonModel | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## assignModelType()

void BALL::VIEW::AddCartoonModel::assignModelType | ( | ModelPart & | part | ) |

protected virtual

Reimplemented from BALL::VIEW::AddBackboneModel.

## assignNucleotideAtoms_()

bool BALL::VIEW::AddCartoonModel::assignNucleotideAtoms_ | ( | Residue & | r,
|  | Size | nr_atoms,
|  | String | atom_names[10],
|  | Atom * | atoms[10] )

protected

## calculateComplementaryBases_()

void BALL::VIEW::AddCartoonModel::calculateComplementaryBases_ | ( | const Composite & | composite | ) |

protected

## calculateModelParts()

void BALL::VIEW::AddCartoonModel::calculateModelParts | ( | Protein & | protein | ) |

protected virtual

Reimplemented from BALL::VIEW::AddBackboneModel.

## create6Ring_()

Mesh * BALL::VIEW::AddCartoonModel::create6Ring_ | ( | vector< Vector3 > | positions | ) |

protected

## createDoubleRing_()

Mesh * BALL::VIEW::AddCartoonModel::createDoubleRing_ | ( | const vector< Vector3 > & | positions | ) |

protected

## createHelix_()

void BALL::VIEW::AddCartoonModel::createHelix_ | ( | Position | set_first,
|  | Position | part_pos )

protected

## createModel_()

void BALL::VIEW::AddCartoonModel::createModel_ | ( | Position | set_pos,
|  | Position | part_pos )

protected virtual

Reimplemented from BALL::VIEW::AddBackboneModel.

## createSimpleNucleicAcid_()

void BALL::VIEW::AddCartoonModel::createSimpleNucleicAcid_ | ( | Position | set_pos,
|  | Position | part_pos )

protected

## createStrand_()

void BALL::VIEW::AddCartoonModel::createStrand_ | ( | Position | set_pos,
|  | Position | part_pos )

protected

## createTubeHelix_()

void BALL::VIEW::AddCartoonModel::createTubeHelix_ | ( | Position | set_first,
|  | Position | part_pos )

protected

## createWatsonCrickModel_()

void BALL::VIEW::AddCartoonModel::createWatsonCrickModel_ | ( | Position | set_pos,
|  | Position | part_pos )

protected

## drawDNAAsLadderModel()

bool BALL::VIEW::AddCartoonModel::drawDNAAsLadderModel | ( |  | ) |

inline

Definition at line 111 of file cartoonModel.h.

## drawRiboseAtoms_()

void BALL::VIEW::AddCartoonModel::drawRiboseAtoms_ | ( | const Atom * | atom1,
|  | const Atom * | atom2,
|  | const Vector3 & | v1,
|  | const Vector3 & | v2 )

protected

## drawStrand_()

void BALL::VIEW::AddCartoonModel::drawStrand_ | ( | const Vector3 & | start,
|  | Vector3 & | right,
|  | Vector3 & | hn,
|  | float | arrow_width,
|  | Position & | last_vertices,
|  | Mesh & | mesh )

inline protected

## enableRibbons()

void BALL::VIEW::AddCartoonModel::enableRibbons | ( | bool | state | ) |

inline

Definition at line 115 of file cartoonModel.h.

## getArrowWidth()

float BALL::VIEW::AddCartoonModel::getArrowWidth | ( |  | ) | const

inline

Definition at line 63 of file cartoonModel.h.

## getDNABaseRadius()

float BALL::VIEW::AddCartoonModel::getDNABaseRadius | ( |  | ) | const

inline

Definition at line 87 of file cartoonModel.h.

## getDNAHelixRadius()

float BALL::VIEW::AddCartoonModel::getDNAHelixRadius | ( |  | ) | const

inline

Definition at line 95 of file cartoonModel.h.

## getDNALadderRadius()

float BALL::VIEW::AddCartoonModel::getDNALadderRadius | ( |  | ) | const

inline

Definition at line 103 of file cartoonModel.h.

## getHelixRadius()

float BALL::VIEW::AddCartoonModel::getHelixRadius | ( |  | ) | const

inline

Definition at line 55 of file cartoonModel.h.

## getStrandHeight()

float BALL::VIEW::AddCartoonModel::getStrandHeight | ( |  | ) | const

inline

Definition at line 71 of file cartoonModel.h.

## getStrandWidth()

float BALL::VIEW::AddCartoonModel::getStrandWidth | ( |  | ) | const

inline

Definition at line 79 of file cartoonModel.h.

## insertTriangle_()

void BALL::VIEW::AddCartoonModel::insertTriangle_ | ( | Position | v1,
|  | Position | v2,
|  | Position | v3,
|  | Mesh & | mesh )

protected

## refineGuidePoints_()

virtual void BALL::VIEW::AddCartoonModel::refineGuidePoints_ | ( |  | ) |

protected virtual

Reimplemented from BALL::VIEW::AddBackboneModel.

## renderNucleotideOutline_()

void BALL::VIEW::AddCartoonModel::renderNucleotideOutline_ | ( | const vector< Vector3 > & | positions,
|  | Vector3 | uv,
|  | Mesh & | mesh )

protected

## ribbonsEnabled()

bool BALL::VIEW::AddCartoonModel::ribbonsEnabled | ( |  | ) | const

inline

Definition at line 119 of file cartoonModel.h.

## setArrowWidth()

void BALL::VIEW::AddCartoonModel::setArrowWidth | ( | float | width | ) |

inline

Definition at line 59 of file cartoonModel.h.

## setDNABaseRadius()

void BALL::VIEW::AddCartoonModel::setDNABaseRadius | ( | float | r | ) |

inline

Definition at line 83 of file cartoonModel.h.

## setDNAHelixRadius()

void BALL::VIEW::AddCartoonModel::setDNAHelixRadius | ( | float | r | ) |

inline

Definition at line 91 of file cartoonModel.h.

## setDNALadderRadius()

void BALL::VIEW::AddCartoonModel::setDNALadderRadius | ( | float | r | ) |

inline

Definition at line 99 of file cartoonModel.h.

## setDrawDNAAsLadderModel()

void BALL::VIEW::AddCartoonModel::setDrawDNAAsLadderModel | ( | bool | state | ) |

inline

Definition at line 107 of file cartoonModel.h.

## setHelixRadius()

void BALL::VIEW::AddCartoonModel::setHelixRadius | ( | float | radius | ) |

inline

Definition at line 51 of file cartoonModel.h.

## setStrandHeight()

void BALL::VIEW::AddCartoonModel::setStrandHeight | ( | float | heigth | ) |

inline

Definition at line 67 of file cartoonModel.h.

## setStrandWidth()

void BALL::VIEW::AddCartoonModel::setStrandWidth | ( | float | w | ) |

inline

Definition at line 75 of file cartoonModel.h.

## Member Data Documentation

## arrow_width_

float BALL::VIEW::AddCartoonModel::arrow_width_

protected

Definition at line 156 of file cartoonModel.h.

## complementary_bases_

HashMap<const Residue*, const Residue*> BALL::VIEW::AddCartoonModel::complementary_bases_

protected

Definition at line 168 of file cartoonModel.h.

## DNA_base_radius_

float BALL::VIEW::AddCartoonModel::DNA_base_radius_

protected

Definition at line 161 of file cartoonModel.h.

## DNA_helix_radius_

float BALL::VIEW::AddCartoonModel::DNA_helix_radius_

protected

Definition at line 159 of file cartoonModel.h.

## DNA_ladder_radius_

float BALL::VIEW::AddCartoonModel::DNA_ladder_radius_

protected

Definition at line 160 of file cartoonModel.h.

## draw_DNA_as_ladder_

bool BALL::VIEW::AddCartoonModel::draw_DNA_as_ladder_

protected

Definition at line 165 of file cartoonModel.h.

## draw_ribbon_

bool BALL::VIEW::AddCartoonModel::draw_ribbon_

protected

Definition at line 166 of file cartoonModel.h.

## helix_height_

float BALL::VIEW::AddCartoonModel::helix_height_

protected

Definition at line 154 of file cartoonModel.h.

## helix_radius_

float BALL::VIEW::AddCartoonModel::helix_radius_

protected

Definition at line 153 of file cartoonModel.h.

## helix_width_

float BALL::VIEW::AddCartoonModel::helix_width_

protected

Definition at line 155 of file cartoonModel.h.

## ribbon_radius_

float BALL::VIEW::AddCartoonModel::ribbon_radius_

protected

Definition at line 163 of file cartoonModel.h.

## ribbon_width_

float BALL::VIEW::AddCartoonModel::ribbon_width_

protected

Definition at line 162 of file cartoonModel.h.

## strand_height_

float BALL::VIEW::AddCartoonModel::strand_height_

protected

Definition at line 158 of file cartoonModel.h.

## strand_width_

float BALL::VIEW::AddCartoonModel::strand_width_

protected

Definition at line 157 of file cartoonModel.h.